/*
 *  Sysop Module Main.c
 *
 *	This program source code and it's compiled version is
 *  Copyright (c) 1991 N. Hawthorn.
 *  This program source code and it's compiled version IS NOT IN THE
 *  PUBLIC DOMAIN ! Please read the "COPYRIGHT NOTICE / NH" file for details
 *  regarding use of this program source code and it's compiled version.
 *
 *  This module's name is "sysop", it's type is "MOD1", use a resource mover
 *  to assign a new number to it, that's why we name our modules !
 *
 *  This is where it all starts...
 *
 */

#define INMAIN

#include <SetUpA4.h>
#include "MUBBS Module.h"

struct PPP {
			char passstring[260]; /* the string to pass to the module */
			int field;   /* the field to get */
			int uerror;   /* any errors found ? */
			};


/* my globals for this file */



pascal void main (mode1,G1,P) /* called from the main routines, and what mode to be in */
int mode1;
struct GS *G1; /* we point to the "global" struct in the Main Module here */
Ptr P; /* we ignore this pointer, we do not use it at all */
{
Handle temph;
float version = 0.5; /* what version of MUBBS you are compatable with IE: .5 and above */
RememberA0(); SetUpA4(); /* This sets up the A4 register to access our globals */
asm { _RecoverHandle }; asm {move.l a0,temph}; HLock(temph); /* locks our module, do this ! */

G=G1; /* This MUST be the first thing you do in main only, it sets up the struct globals */
mode[u]=mode1; /* set up our mode so that you can read it anywhere */

switch (mode[u]) { /* any un-handled modes return error from this module */
	case 2:
		doit();
		G->moduleresult=0;
		break;
	case 98:
		versionck(version); /* just return after this call, don't modify anything */
		break;		
	case 0:
		strcpy (G->programmer,"N Hawthorn"); /* show the programmer's name up to 20 chars*/
		G->moduleresult=0; /* this was also a init call if we need close call put 99 here */
		break;
	default:
		G->moduleresult=1; /* return bad code */
	};

HUnlock(temph); /* unlocks this module, do this ! */
RestoreA4(); /* call this when you are all done */
}


doit()
{
int i;
char temp[128], temp2[128];

if (!G->online[u]) goto done; /* do this check so we can log out if hang up */

loguser("SYSOP MENU !!"); /* this tells where you are for remote sysop, or writes to log file */

/* you print the following so that the sysop can monitor use on the mac screen */

print("\nC> SYSOP Menu, user is :%s at %s baud on line #%d with access :%d ",G->username[u],G->userbaud[u],(u+1),G->userpriv[u]);

if (G->userpriv[u] <19) goto done;

loop:
send("]]  *** SYSOP ***]]");
if (!(cmd1(">> Operations, Readlogs, Who's on, Quit :"))) goto byebye; /* timeout */
send (G->CR[u]);
switch (G->input[u]) {
	case 'O':
		operations();
		break;
	case 'R':
		goto loop2;
		break;
	case 'W':
		for (i = 0; i < G->users; i++) {
			if (G->online[i]) {
				send("]Line %d \"%s\" at %s baud with access :%d ",(i+1),G->username[i],G->userbaud[i],G->userpriv[i]);
				send("]       Location :%s ",G->userlocation[i]);
				}
			else send("]Line %d INACTIVE]",(i+1));
			}
		if (!G->online[u]) goto byebye; /* log out */
		send ("]---------------------------------------------------------------------------]");
		break;
	case 'Q':		/* Quit */
		return;
		break;
	}
if (!G->online[u]) goto byebye; /* log out */
goto loop;

loop2:
send("]]  *** Read Log Files ***]]");
if (!(cmd1(">> Downloadlog, Loginuserlog, Systemlog, Uploadlog, Quit :"))) goto byebye; /* timeout */
send (G->CR[u]);
send (G->CR[u]); /* these files don't have a CR at start */
switch (G->input[u]) {
	case 'D':
		backwardsfile (":logs:downloadlog");
		if (!G->online[u]) goto byebye; /* log out */
		send ("]---------------------------------------------------------------------------]");
		break;
	case 'L':
		backwardsfile (":logs:userlog");
		if (!G->online[u]) goto byebye; /* log out */
		send ("]---------------------------------------------------------------------------]");
		break;
	case 'S':
		backwardsfile (":logs:systemlog");
		if (!G->online[u]) goto byebye; /* log out */
		send ("]---------------------------------------------------------------------------]");
		break;
	case 'U':
		backwardsfile (":logs:uploadlog");
		if (!G->online[u]) goto byebye; /* log out */
		send ("]---------------------------------------------------------------------------]");
		break;
	case 'Q':		/* Quit */
		goto loop;
		break;
	}
if (!G->online[u]) goto byebye; /* log out */
goto loop2;


byebye:
G->online[u]=FALSE; /* show we timed out */
done:
return;
}


operations()
{
char datetime[25],tempfile[25], temp[128], temp2[128];
int tries;
FILE *stream;

if (getpass()) goto okpass;

getdatetime(datetime); /* gets the date & time */
tries = 0;
bsylp:
if ((stream = fopen(":logs:userlog", "a")) == NULL) {	/* add to the file */
	if (++tries < 10) {
		send("PLEASE STANDBY]");
		wait(1); /* wait just a bit */
		goto bsylp;
		}
	send("FILE ERROR - Can't open the userlog file!]");
	fclose(stream);
	}
else {
	if (fprintf(stream, "** SYSOP ** ACCESS DENIED !! %s %s %s LINE=%d\n", datetime, G->username[u], G->userbaud[u], (u+1)) < 0) {
		send("FILE ERROR %d - userlog file file has problem writing]");
		fclose(stream);
		}
	}
fclose(stream);
print("** SYSOP ** ACCESS DENIED TO: %s %s LINE=%d\n", G->username[u], G->userbaud[u], (u+1));
send("]]ACCESS DENIED..]]");
G->online[u]=FALSE;
return;


okpass:
send("]]  *** Heavy Sysop Stuff  BE CAREFUL HERE !!  ***]]");
if (!(cmd1(">> Edit user, User list, Verify user list, Quit :"))) goto byebye; /* timeout */
send (G->CR[u]);
switch (G->input[u]) {
	case 'E':
		edituserinfo();
		break;
	case 'U':
		listusers();
		break;
	case 'V':
		checkuserlist();
		break;
	case 'Q':		/* Quit */
		return;
		break;
	}
if (!G->online[u]) goto byebye; /* log out */
goto okpass;


byebye:
G->online[u]=FALSE; /* show we timed out */
return;
}

getpass()
{
char temp[40];
char password[40];
FILE *stream;
if ((stream = fopen(":bbssupport:sysopstuff", "r")) == NULL) {
    send("] ERROR ! Cannot open 'sysopstuff' file !!]"); 
    return FALSE;
	}
else {
	fscanf(stream,"%30[^\n]\n",password);
	fclose(stream);
	}

strtoupper(password); /* uppercase the password */

send("]Sysop Password :");
passportsin(temp, 30);
strtoupper(temp); /* uppercase the password */
send(G->CR[u]);
if (! G->online[u]) return FALSE; /* returns online for a time out */
if (strcmp(password,temp) == 0) {
	return TRUE;
	}
return FALSE;
}



listusers()
{
char tempname[maxnamelength];
char tempalias[maxnamelength];
char temppass[maxnamelength];
char tempaddress[maxnamelength];
char tempcity[maxnamelength];
char tempphone[maxnamelength];
char tempmachine[maxnamelength];
char tempfirst[maxnamelength];
char templevel[maxnamelength];
char tempsettings[maxnamelength];
char tempbirth[maxnamelength];
char tempextras1[maxnamelength];
char tempextras2[maxnamelength];
char tempmins[maxnamelength];
char temptimes[maxnamelength];
char templast[maxnamelength];
char tempupdown[maxnamelength];
char tempcomments[260];
char tchar[260], temp[65];
int lnum,tempint,got,chars;
long int pos;
FILE *stream;

send("]User List Printout :]]");

if ((stream = fopen(":user:userlist", "r")) == NULL) {
    print("C> FILE ERROR - cannot open user:userlist\n");
	send("]FILE ERROR - Can't open the user list file !]");
	goto endthis;
	}

more:
	pos = ftell(stream); /* get the current file position */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempname);  /* the user's name */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempalias); if (feof(stream)) goto goteof; /* the user's alias */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",temppass); if (feof(stream)) goto goteof; /* the user's password */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",templevel); if (feof(stream)) goto goteof; /* the user's access level */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempaddress); if (feof(stream)) goto goteof; /* the user's address */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempcity); if (feof(stream)) goto goteof; /* the user's city and state */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempphone); if (feof(stream)) goto goteof; /* the user's phone number */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempmachine); if (feof(stream)) goto goteof; /* the user's machine */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempfirst); if (feof(stream)) goto goteof; /* date first logged in */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempsettings); if (feof(stream)) goto goteof; /* user's settings */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempbirth); if (feof(stream)) goto goteof; /* birth info */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempextras1); if (feof(stream)) goto goteof; /* any other info for later use */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempextras2); if (feof(stream)) goto goteof; /* any other info for later use */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",temptimes); if (feof(stream)) goto goteof; /* the number of times this user has been on */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",templast); if (feof(stream)) goto goteof; /* the last date user was on */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempmins); if (feof(stream)) goto goteof; /* the time the user was on last time */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempupdown); if (feof(stream)) goto goteof; /* uploads/downloads */
	fgets(tchar,258,stream); sscanf(tchar,"%255[^~]",tempcomments);  /* comments field for the user */

chars = (ftell(stream) - pos);
if(chars != 801) { /* (entire record should be 801 chars)*/
	pos = ftell(stream);
	send("]]ERROR on record position %ld, got %d chars, should be 801 !]",pos,chars);
	goto endthis;
	}

send("%s]",tempname);
tempint=strtoint(templevel); /* check to see if we have privs to read this */
if (G->userpriv[u] < tempint) {
	send("]You do not have privledges to access this record!]");
	goto more;
	}
send("%s]",tempaddress);
send("%s]",tempcity);
send("%s]",tempphone);
removespaces(templevel); /* takes out trailing spaces */
removespaces(tempmachine); /* takes out trailing spaces */
removespaces(templast); /* takes out trailing spaces */
removespaces(temptimes); /* takes out trailing spaces */
removespaces(tempcomments); /* takes out trailing spaces */
send("Level %s, mach. %s, Calls %s, Last %s]Comm: %s]]",templevel,tempmachine,temptimes,templast,tempcomments);
if (!G->cancel[u]) goto more;

goteof:
send("]--EOF--]");
fclose(stream);
endthis:
return;
}



edituserinfo()
{
char tempname[maxnamelength];
char tempalias[maxnamelength];
char temppass[maxnamelength];
char tempaddress[maxnamelength];
char tempcity[maxnamelength];
char tempphone[maxnamelength];
char tempmachine[maxnamelength];
char tempfirst[maxnamelength];
char templevel[maxnamelength];
char tempsettings[maxnamelength];
char tempbirth[maxnamelength];
char tempextras1[maxnamelength];
char tempextras2[maxnamelength];
char tempmins[maxnamelength];
char temptimes[maxnamelength];
char templast[maxnamelength];
char tempupdown[maxnamelength];
char tempcomments[260];
char tchar[260], ans[33], temp[65];
int lnum,tempint,chars;
long int pos;
struct PPP P; /* make the struct here ! */
FILE *stream;

backname:
send("]Enter the user's name or RETURN to quit :");
portsin(ans,30);
send(G->CR[u]);
if (ans[0] == '\0') return;

if ( ! getuserinfo(ans)) {	; /* see if this user exists */
	send ("]]Sorry, that name doesn't exist. Please select another...]");
	goto backname;
	}
showloop:
if ((stream = fopen(":user:userlist", "r")) == NULL) {
    print("C> FILE ERROR - cannot open :user:userlist\n");
	send("]FILE ERROR - Can't open the user list file !]");
	goto endthis1;
	}

/* start at the users file position */
if(fseek(stream,G->userfilepos[u],0) != 0) print("\nC> Fseek failed ");
	pos = ftell(stream); /* get the current file position */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempname);  /* the user's name */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempalias); if (feof(stream)) goto goteof; /* the user's alias */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",temppass); if (feof(stream)) goto goteof; /* the user's password */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",templevel); if (feof(stream)) goto goteof; /* the user's access level */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempaddress); if (feof(stream)) goto goteof; /* the user's address */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempcity); if (feof(stream)) goto goteof; /* the user's city and state */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempphone); if (feof(stream)) goto goteof; /* the user's phone number */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempmachine); if (feof(stream)) goto goteof; /* the user's machine */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempfirst); if (feof(stream)) goto goteof; /* date first logged in */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempsettings); if (feof(stream)) goto goteof; /* user's settings */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempbirth); if (feof(stream)) goto goteof; /* birth info */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempextras1); if (feof(stream)) goto goteof; /* any other info for later use */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempextras2); if (feof(stream)) goto goteof; /* any other info for later use */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",temptimes); if (feof(stream)) goto goteof; /* the number of times this user has been on */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",templast); if (feof(stream)) goto goteof; /* the last date user was on */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempmins); if (feof(stream)) goto goteof; /* the time the user was on last time */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempupdown); if (feof(stream)) goto goteof; /* uploads/downloads */
	fgets(tchar,258,stream); sscanf(tchar,"%255[^~]",tempcomments);  /* comments field for the user */

chars = (ftell(stream) - pos);
if(chars != 801) { /* (entire record should be 801 chars)*/
	pos = ftell(stream);
	send("]]ERROR on record position %ld, got %d chars, should be 801 !]",pos,chars);
	goto endthis;
	}

tempint=strtoint(templevel); /* check to see if we have privs to read this */
if (G->userpriv[u] < tempint) {
	send("]You do not have privledges to access this record !]");
	goto endthis;
	}
send("]User info fields:]");
send(" 1. Name     = %s]",tempname);
send(" 2. Alias    = %s]",tempalias);
send(" 3. Pass     = %s]",temppass);
send(" 4. Level    = %s]",templevel);
send(" 5. Address  = %s]",tempaddress);
send(" 6. City     = %s]",tempcity);
send(" 7. Phone    = %s]",tempphone);
send(" 8. Machine  = %s]",tempmachine);
send(" 9. First on = %s]",tempfirst);
send("10. Settings = %s]",tempsettings);
send("11. Birth    = %s]",tempbirth);
send("12. Allmsg   = %s]",tempextras1);
send("13. Extras   = %s]",tempextras2);
send("14. Times on = %s]",temptimes);
send("15. Last  on = %s]",templast);
send("16. Mins on  = %s]",tempmins);
send("17. Up/Down  = %s]",tempupdown);
removespaces(tempcomments); /* takes out trailing spaces */
send("18. Comments =]%s]",tempcomments);

send(G->CR[u]);
send("Enter field number to edit or RETURN to exit :");
portsin(ans, 2);
send(G->CR[u]);
if (ans[0] == '\0') goto endthis;
lnum = strtoint(ans);
if (lnum <= 0) goto endthis;
if (lnum > 18) goto endthis;
send("]Enter new text or RETURN to quit:");
if (lnum == 18) {portsin(ans,255);}
else portsin(ans,30);
send(G->CR[u]);
if (ans[0] == '\0') goto endthis;
fclose(stream);
if (lnum == 18) {sprintf(P.passstring,"%-255s~\n",ans);}
else sprintf(P.passstring,"%-30s~\n",ans);
P.field = lnum; /* Replace user's field */
module (3,"putuserfield",&P); /* int mode & module's name & pointer to the P struct */
if ( ! P.uerror){ 
	send("]ERROR TRYING TO UPDATE USER FIELD %d]",lnum);
	}
else send("]User's field #%d has been updated..]",lnum);
goto showloop;

goteof:
endthis:
fclose(stream);
endthis1:
getuserinfo(G->username[u]); /* set my file position back */
}


getuserinfo(gettemp)
char *gettemp;
{
char tempname[maxnamelength];
char temp1[maxnamelength],temp2[maxnamelength];
char tchar[260];
int count;
long pos;
FILE *stream;

if ((stream = fopen(":user:userlist", "r")) == NULL) {
    print("C> FILE ERROR - cannot open :bbsuser:userlist\n");
	send("]FILE ERROR - Can't open the user list file !]");
	return FALSE;
	}
count = 0;
pos=0;
sprintf(temp2,"%-30s",gettemp); /* Prepare the user name for compare */
strtoupper(temp2);

while (TRUE){

	if(fseek(stream,pos,0) != 0) print("C> Fseek failed\n"); /* go to the record */
	fscanf(stream,"%30[^~]",tempname); if (feof(stream)) goto goteof;  /* the user's name */
	strcpy(temp1,tempname); /* save the actual name for later */
	strtoupper(tempname);
	if (strcmp(tempname,temp2) == 0) {
		G->userfilepos[u]=pos; /* save the file position for later reference */
		removespaces(temp1); /* takes out trailing spaces */
		strcpy(gettemp,temp1); /* make their name correct */
		fclose(stream);
		return TRUE;
		}
	otheruser(FALSE); /* do switch */
	if ((++count % 10) == 0) {sendnc (".");} /* show dots */
	pos=pos+801; /* move up a record */
	}
goteof:
fclose(stream);
return FALSE;  /* user was not found */

}



checkuserlist() /* goes through the list and checks for correct spacing of data */
{
char tempname[maxnamelength];
char tempalias[maxnamelength];
char temppass[maxnamelength];
char tempaddress[maxnamelength];
char tempcity[maxnamelength];
char tempphone[maxnamelength];
char tempmachine[maxnamelength];
char tempfirst[maxnamelength];
char templevel[maxnamelength];
char tempsettings[maxnamelength];
char tempbirth[maxnamelength];
char tempextras1[maxnamelength];
char tempextras2[maxnamelength];
char tempmins[maxnamelength];
char temptimes[maxnamelength];
char templast[maxnamelength];
char tempupdown[maxnamelength];
char tempcomments[260];
char temp1[maxnamelength], temp2[maxnamelength];
char tchar[260], temp[65];
int count,got,chars;
long pos;
FILE *stream;

send("]Checking userlist by reading all records and checking for extra or missing chars]");

if ((stream = fopen(":user:userlist", "r")) == NULL) {
    print("C> FILE ERROR - cannot open :user:userlist\n");
	send("]FILE ERROR - Can't open the user list file !]");
	return (FALSE);
	}
count = 0;

while (TRUE){

	pos = ftell(stream); /* get the current file position */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempname);  /* the user's name */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempalias); if (feof(stream)) goto goteof; /* the user's alias */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",temppass); if (feof(stream)) goto goteof; /* the user's password */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",templevel); if (feof(stream)) goto goteof; /* the user's access level */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempaddress); if (feof(stream)) goto goteof; /* the user's address */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempcity); if (feof(stream)) goto goteof; /* the user's city and state */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempphone); if (feof(stream)) goto goteof; /* the user's phone number */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempmachine); if (feof(stream)) goto goteof; /* the user's machine */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempfirst); if (feof(stream)) goto goteof; /* date first logged in */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempsettings); if (feof(stream)) goto goteof; /* user's settings */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempbirth); if (feof(stream)) goto goteof; /* birth info */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempextras1); if (feof(stream)) goto goteof; /* any other info for later use */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempextras2); if (feof(stream)) goto goteof; /* any other info for later use */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",temptimes); if (feof(stream)) goto goteof; /* the number of times this user has been on */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",templast); if (feof(stream)) goto goteof; /* the last date user was on */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempmins); if (feof(stream)) goto goteof; /* the time the user was on last time */
	fgets(tchar,33,stream); if (feof(stream)) goto goteof; sscanf(tchar,"%30[^~]",tempupdown); if (feof(stream)) goto goteof; /* uploads/downloads */
	fgets(tchar,258,stream); sscanf(tchar,"%255[^~]",tempcomments);  /* comments field for the user */


chars = (ftell(stream) - pos);
if(chars != 801) { /* (entire record should be 801 chars)*/
	pos = ftell(stream);
	send("]]ERROR in userlist at position %ld ! Check it out !]",pos);
	print("\nC> ERROR on record position %ld, got %d chars, should be 801 !\n",pos,chars);
	fclose(stream);
	return FALSE;
	}
	otheruser(FALSE); /* do switch */
	if ((++count % 10) == 0) {sendnc (".");} /* show dots */
	}
goteof:
fclose(stream);
send("]User list checks out OK !]");
return TRUE;  /* records are OK */
}




backwardsfile(thefile)
char *thefile;
{
char temp[520],output[520],nexttime[520];
long int seek,startfile,endfile, strstart, strend, got,toget;
int endoffile,count,i,err1,a;
FILE *stream;

if ((stream = fopen(thefile, "r")) == NULL) {
    print("C> FILE ERROR - cannot open \"%s\"\n",thefile);
    send("]FILE ERROR - Cannot open \"%s\"]",thefile);
    return;
	}

strcpy (nexttime,""); /* blank this out for now */

startfile=ftell(stream);

if(err1=fseek(stream,0,2) != 0) print("Fseek to end failed\n"); /* go to end of file */
endfile=ftell(stream);
seek=endfile-512; /* back up 512 */
endoffile=FALSE;
toget=512; /* start out getting 512 characters */

while(!endoffile) {

	if (seek < 0) {
		toget=512+seek; /* get the difference in characters, seek is negative */
		seek=0;
		}

	if (seek==0) endoffile=TRUE;

	if(err1=fseek(stream,seek,0) != 0) print("Fseek failed\n");

	got=fread(&temp[0],1,toget,stream);

	temp[got]='\0'; /* remember! the string starts at 0, got it end +1 */

	if (got < 512) endoffile=TRUE;
	if (got == 0) break;

	strstart= (strlen(temp) -1); /* find the end of it */

	strend=strstart;


	while (strend > 0) {

		 do { 
			strend--;
			} while (temp[strend] != 0x0A && strend >0) ;/* go to the start of line */

		i=0;
		if (strend == 0) count= 0;
		else count=strend +1;

		while (count <= strstart){ /* copy the string over */
			output[i]=temp[count];
			i++;
			count++;
			}
		output[i]='\0';

		strstart=strend;

		if (strend == 0 && !endoffile) {
			strcpy (nexttime,output); /* save the line for next time */
			}
		else {	
			strcat(output,nexttime); /* add in any from last time */
			a=0;
			while (output[a] != '\0') {
				if (G->okcancel[u]) {if (G->cancel[u]) break;} /* check for cancel press */
				if ((output[a] == 0x0A) || (output[a] == 0x0D)) { send(G->CR[u]); }
				else G->out(output[a]);
				++a;
				}
			strcpy (nexttime,""); /* we used it so blank it out */
			}
		}
	seek=seek-512; /* back up 512 */

	}
G->cont[u]=FALSE; /* set for term line counting */
}


